{{
  Test PFunc - the PASM Functionalizer

  Jonathan "lonesock" Dummer
}}

' set for the standard 5MHz crystal...this must be correct for the serial code to work
CON
  _CLKMODE = XTAL1 + PLL16X 
  _XINFREQ = 5_000_000

OBJ
  term          : "FullDuplexSerial"
  pf            : "PFunc"
  
PUB main | i, s, tSpin, tPF

  ' init my objects
  term.start( 31, 30, 0, 115_200 )
  waitcnt( (clkfreq >> 2) + cnt )
  pf.start

  ' OK, try testing something
  pf.run( @pf_SimpleTest, @i )
  term.str( string( 13, 13, "The simple test: 105 =?= " ) )
  term.dec( i )
  term.tx( 13 )

  ' Try the 2nd test
  i := 254870
  's := i
  tSpin := -cnt
  s := ^^i
  tSpin += cnt
  tPF := -cnt
  pf.run( @pf_TestSQRT, @i )
  tPF += cnt
  term.str( string( "The sqrt test: " ) )
  term.dec( s )
  term.str( string( " =?= " ) )
  term.dec( i )
  term.str( string( 13, "Timing (PF vs Spin): " ) )
  term.dec( tPF )
  term.str( string( " vs " ) )
  term.dec( tSpin )
  term.tx( 13 )
    

'' simple example: write a value into (fake) PAR
DAT
ORG pf#PAR_address
pf_SimpleTest           long    startvalue-pf_SimpleTest ' length of this routine (excluding this register)
                        mov     value, startvalue
                        add     value, #5
                        wrlong  value, pf#PAR_address

                        jmp     #0                      ' done with the function

startvalue    long      100
value         res       1


'' harder example, take the square-root of an integer
DAT
ORG pf#PAR_address
pf_TestSQRT             long    mask-pf_TestSQRT ' length of this routine (excluding this register)
                        rdlong  input, pf#PAR_address 
                        mov     root, #0                'reset root
:loop                   or      root,mask       'set trial bit
                        cmpsub  input,root wc   'subtract root from input if fits
                        sumnc   root,mask       'cancel trial bit, set root bit if fit
                        shr     root,#1         'shift root down
                        ror     mask,#2 wc      'shift mask down
              if_nc     jmp     #:loop          'loop until mask empty
                        wrlong  root, pf#PAR_address

                        jmp     #0                      ' done with the function

mask          long      $40000000
input         res       1
root          res       1